<template>
  <div class="list-container">
    <BackToBall />
    <BackToTopBall />
    <el-table :data="model" border stripe size="mini">
      <el-table-column type="index" :index="rowNum" fixed="left" show-overflow-tooltip />
      <el-table-column prop="regionId" label="地區代號" />
      <el-table-column prop="custId" label="客戶代號" />
      <el-table-column prop="personTypeName" label="客戶類別" show-overflow-tooltip />
      <el-table-column prop="locName" label="本地名字" show-overflow-tooltip />
      <el-table-column prop="engName" label="英文名字" show-overflow-tooltip />
      <el-table-column prop="custLevel" label="客戶等級" show-overflow-tooltip />
      <el-table-column prop="personId" label="身分證號" />
      <el-table-column fixed="left" align="center" label="編輯" width="140">
        <template slot-scope="scope">
          <el-button
            icon="el-icon-edit"
            type="primary"
            size="mini"
            circle
            @click="rowSelected(scope.row, 'update')"
          />
          <el-button
            icon="el-icon-delete"
            type="danger"
            size="mini"
            circle
            @click="rowSelected(scope.row, 'delete')"
          />
          <!-- v-permission="'query'" -->
          <el-button
            icon="el-icon-search"
            type="info"
            size="mini"
            circle
            @click="rowSelected(scope.row, 'view')"
          />
        </template>
      </el-table-column>
    </el-table>
    <el-pagination
      background
      :total="total"
      :current-page="condition.current"
      :page-size="condition.pageSize"
      :page-sizes="[10, 20, 30]"
      layout="->, total, prev, pager, next, sizes, jumper"
      @current-change="changePage"
      @size-change="changeSize"
    />
    <el-button type="primary" icon="el-icon-download" size="small" class="btn-download">下載</el-button>
  </div>
</template>

<script>
import { listData, saveRowData, countRowNum, doChangePage, doChangeSize } from '@/utils/common'

export default {
  data() {
    const data = {}
    return Object.assign(listData(), data)
  },
  methods: {
    rowSelected(row, action) {
      saveRowData(row, action)
      this.$router.push({ path: action })
    },
    rowNum(index) {
      return countRowNum(this.condition.current, index)
    },
    changePage: function(current) {
      doChangePage(current).then(resp => {
        this.condition = resp.condition
        this.total = resp.total
        this.model = resp.data
      })
    },
    changeSize: function(pageSize) {
      doChangeSize(pageSize)
      this.changePage(1)
    }
  }
}
</script>
